package com.example.moventaa.bean;

import java.util.Date;

import javax.jdo.annotations.IdGeneratorStrategy;
import javax.jdo.annotations.IdentityType;
import javax.jdo.annotations.PersistenceCapable;
import javax.jdo.annotations.Persistent;
import javax.jdo.annotations.PrimaryKey;

import com.google.appengine.api.datastore.Blob;

/**
 * Entidad que representa la baja enviada de un empleado
 * 
 * @author mmartinezced
 *
 */
@PersistenceCapable(identityType = IdentityType.APPLICATION)
public class Baja {

	
	@PrimaryKey
	@Persistent(valueStrategy = IdGeneratorStrategy.IDENTITY)
	//clave primara
	private Long id;

	@Persistent
	//relacion con el empleado
	private String idEmpleado;
	
	@Persistent
	//fecha de la baja
	private Date date;
	
	@Persistent
	private String tipo;
	
    @Persistent
    //imagen del justificante de la baja
    Blob image;
    
    //~ ---------------- getter & setter

	public Date getDate() {
		return date;
	}

	public void setDate(Date date) {
		this.date = date;
	}

	public Blob getImage() {
		return image;
	}

	public void setImage(Blob image) {
		this.image = image;
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getIdEmpleado() {
		return idEmpleado;
	}

	public void setIdEmpleado(String idEmpleado) {
		this.idEmpleado = idEmpleado;
	}

	public String getTipo() {
		return tipo;
	}

	public void setTipo(String tipo) {
		this.tipo = tipo;
	}

    
}
