package com.example.moventaa.bean;

import java.sql.Date;
import java.util.List;

import javax.jdo.annotations.IdGeneratorStrategy;
import javax.jdo.annotations.IdentityType;
import javax.jdo.annotations.PersistenceCapable;
import javax.jdo.annotations.Persistent;
import javax.jdo.annotations.PrimaryKey;

import com.google.appengine.api.datastore.Key;

/**
 * Entidad que representa el empleado
 * @author mmartinezced
 *
 */
@PersistenceCapable(identityType = IdentityType.APPLICATION)
public class Empleado {
	
	@PrimaryKey
    @Persistent(valueStrategy = IdGeneratorStrategy.IDENTITY)
	//clave primaria
    private Key key;
	//nombre
	@Persistent	private String nombre;
	//primer apellido
	@Persistent	private String primerApellido;
	//segundo apellido
	@Persistent	private String segundoApellido;
	//documento de identificacion
	@Persistent	private String docIdentificacion;
	//tipo de doc de identificacion (nif, cif...)
	@Persistent	private String tipoDocIdentificacion;
	//fecha de nacimiento
	@Persistent	private Date fechaNacimiento;
	//fecha de alta
	@Persistent	private Date fechaAlta;
	//activo
	@Persistent	private String enabled;
	//bloqueado
	@Persistent	private String bloqued;
	
	//~--------------------------------------- getter & setter
	public Key getKey() {
		return key;
	}
	public void setKey(Key key) {
		this.key = key;
	}
	public String getNombre() {
		return nombre;
	}
	public void setNombre(String nombre) {
		this.nombre = nombre;
	}
	public String getPrimerApellido() {
		return primerApellido;
	}
	public void setPrimerApellido(String primerApellido) {
		this.primerApellido = primerApellido;
	}
	public String getSegundoApellido() {
		return segundoApellido;
	}
	public void setSegundoApellido(String segundoApellido) {
		this.segundoApellido = segundoApellido;
	}
	public String getDocIdentificacion() {
		return docIdentificacion;
	}
	public void setDocIdentificacion(String docIdentificacion) {
		this.docIdentificacion = docIdentificacion;
	}
	public String getTipoDocIdentificacion() {
		return tipoDocIdentificacion;
	}
	public void setTipoDocIdentificacion(String tipoDocIdentificacion) {
		this.tipoDocIdentificacion = tipoDocIdentificacion;
	}
	public Date getFechaNacimiento() {
		return fechaNacimiento;
	}
	public void setFechaNacimiento(Date fechaNacimiento) {
		this.fechaNacimiento = fechaNacimiento;
	}
	public Date getFechaAlta() {
		return fechaAlta;
	}
	public void setFechaAlta(Date fechaAlta) {
		this.fechaAlta = fechaAlta;
	}
	public String getEnabled() {
		return enabled;
	}
	public void setEnabled(String enabled) {
		this.enabled = enabled;
	}
	public String getBloqued() {
		return bloqued;
	}
	public void setBloqued(String bloqued) {
		this.bloqued = bloqued;
	}
	
	
	
}
