package com.example.moventaa.bean;

import javax.jdo.annotations.IdGeneratorStrategy;
import javax.jdo.annotations.PersistenceCapable;
import javax.jdo.annotations.Persistent;
import javax.jdo.annotations.PrimaryKey;

import com.google.appengine.api.datastore.Key;
import com.google.appengine.api.datastore.Link;

/**
 * Entity class que representa los Productos que pueden 
 * ser utilizados
 * 
 * @author mmartinezced
 *
 */
@PersistenceCapable
public class Producto {
	
	@PrimaryKey
	@Persistent(valueStrategy = IdGeneratorStrategy.IDENTITY)
    private Key key;
	
    private String nombre;
	private String descripcion;
	private String codigoBR;
	private Link imagen;
	

	//~ ----- getter&setter 
	
	public Key getKey() {
		return key;
	}
	public void setKey(Key key) {
		this.key = key;
	}
	public String getNombre() {
		return nombre;
	}
	public void setNombre(String nombre) {
		this.nombre = nombre;
	}
	public String getDescripcion() {
		return descripcion;
	}
	public void setDescripcion(String descripcion) {
		this.descripcion = descripcion;
	}
	public String getCodigoBR() {
		return codigoBR;
	}
	public void setCodigoBR(String codigoBR) {
		this.codigoBR = codigoBR;
	}
	public Link getImagen() {
		return imagen;
	}
	public void setImagen(Link imagen) {
		this.imagen = imagen;
	}
	@Override
	public boolean equals(Object obj) {
		return ((Key)obj).getName().equals(this.getKey().getName());
	}
	
	
	
}
