package com.example.moventaa.bean;

import java.util.Date;

import javax.jdo.annotations.IdGeneratorStrategy;
import javax.jdo.annotations.PersistenceCapable;
import javax.jdo.annotations.Persistent;
import javax.jdo.annotations.PrimaryKey;

import com.google.appengine.api.datastore.Key;

/**
 * Entidad que incluye el stock solicitado
 * por un empleado en un un centro para un producto
 * en particular 
 * 
 * @author mmartinezced
 *
 */
@PersistenceCapable
public class StockSolicitado {

   //Clave primaria  
   @PrimaryKey
   @Persistent(valueStrategy = IdGeneratorStrategy.IDENTITY)
   private Key key;

   @Persistent
   private String empleadoID;

   @Persistent
   private String centroID;
   
   @Persistent
   private String productoID;
   
   @Persistent
   private Date fechaSolicitud;
   
   @Persistent
   private Integer cantidad;

	public Key getKey() {
		return key;
	}
	
	public void setKey(Key key) {
		this.key = key;
	}
	
	public String getEmpleadoID() {
		return empleadoID;
	}
	
	public void setEmpleadoID(String empleadoID) {
		this.empleadoID = empleadoID;
	}

	public Date getFechaSolicitud() {
		return fechaSolicitud;
	}
	
	public void setFechaSolicitud(Date fechaSolicitud) {
		this.fechaSolicitud = fechaSolicitud;
	}
	
	public Integer getCantidad() {
		return cantidad;
	}
	
	public void setCantidad(Integer cantidad) {
		this.cantidad = cantidad;
	}

	public String getCentroID() {
		return centroID;
	}

	public void setCentroID(String centroID) {
		this.centroID = centroID;
	}

	public String getProductoID() {
		return productoID;
	}

	public void setProductoID(String productoID) {
		this.productoID = productoID;
	}

   
	   
}
