package com.example.moventaa.bean;

import java.util.Date;

import javax.jdo.annotations.IdGeneratorStrategy;
import javax.jdo.annotations.IdentityType;
import javax.jdo.annotations.PersistenceCapable;
import javax.jdo.annotations.Persistent;
import javax.jdo.annotations.PrimaryKey;

import com.google.appengine.api.datastore.Key;

/**
 * Entidad que incluye el numero de ventas
 * realizadas por un empleado por un producto en 
 * un centro
 * 
 * @author mmartinezced
 *
 */
@PersistenceCapable(identityType = IdentityType.APPLICATION)
public class VentaProductoCentro {

	@PrimaryKey
    @Persistent(valueStrategy = IdGeneratorStrategy.IDENTITY)
    private Key key;
	
	@Persistent
	private String centroId;
	@Persistent
	private String productoId;
	@Persistent
	private String empleadoID;
	@Persistent
	private Date fechaVenta;
	@Persistent
	private Long comision;
	
	
	public Key getKey() {
		return key;
	}
	public void setKey(Key key) {
		this.key = key;
	}
	public String getCentroId() {
		return centroId;
	}
	public void setCentroId(String centroId) {
		this.centroId = centroId;
	}
	public String getProductoId() {
		return productoId;
	}
	public void setProductoId(String productoId) {
		this.productoId = productoId;
	}
	public String getEmpleadoID() {
		return empleadoID;
	}
	public void setEmpleadoID(String empleadoID) {
		this.empleadoID = empleadoID;
	}
	public Date getFechaVenta() {
		return fechaVenta;
	}
	public void setFechaVenta(Date fechaVenta) {
		this.fechaVenta = fechaVenta;
	}
	
	
	
}
