package com.example.moventaa;

import java.io.IOException;
import java.util.Calendar;

import android.app.Activity;
import android.app.DatePickerDialog;
import android.app.Dialog;
import android.app.DialogFragment;
import android.app.ProgressDialog;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.View;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;
import butterknife.ButterKnife;
import butterknife.InjectView;
import butterknife.OnClick;

import com.example.moventaa.bean.moventaaendpoint.Moventaaendpoint;
import com.example.moventaa.bean.moventaaendpoint.model.CollectionResponseEmpleado;
import com.example.moventaa.bean.moventaaendpoint.model.Empleado;
import com.example.moventaa.utils.UserPrefsData;
import com.example.moventaa.utils.Utils;
import com.google.api.client.extensions.android.http.AndroidHttp;
import com.google.api.client.json.jackson2.JacksonFactory;

/**
 * Actividad relacionada con un empleado
 * en esta pantalla se comprueba que el empleado
 * esta dado de alta en la base de datos y que es empleado
 * de la empresa
 * 
 * @author mmartinezced
 */
public class EmployedActivity extends Activity {

	//Progress dialog
	private ProgressDialog progressDialog;
	
	UserPrefsData myData = null;
	
	
	@InjectView(R.id.empl_nombre) TextView nombre;
	@InjectView(R.id.empl_apellidostxt) TextView apellidos;
	@InjectView(R.id.empl_dnitxt) TextView dnitxt;
	@InjectView(R.id.empl_fechanactxt) TextView fechanactxt;
	
	 
	@Override protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_employed);
        
        ButterKnife.inject(this);
        
        myData = Utils.getUserPrefs(this);
        if(myData instanceof UserPrefsData){
        	nombre.setText(myData.getNombre());
        	apellidos.setText(myData.getApellidos());
        	dnitxt.setText(myData.getDocumento());
        	fechanactxt.setText(myData.getFechanac());
        }
        
         
//        final EditText fechanac = (EditText) findViewById(R.id.empl_fechanactxt);
//        fechanac.setOnClickListener(new View.OnClickListener() {
//        	public void onClick(View v) {
//        		DialogFragment newFragment = new DatePickerFragment();
//        	    newFragment.show(getFragmentManager(), "datePicker");
//            }
//        });
        
    }
	
	 
    /**
     * Metodo comprobar usuario en servidor
     */
    @OnClick(R.id.btnBusqCentros)
    public void login(View view){
    	
			String txtuser = nombre.getText().toString();
			if(txtuser==null || txtuser.length()==0){
				Toast.makeText(getBaseContext(),
						"Debe escribir su nombre",
						Toast.LENGTH_LONG).show();
				return;
			}
			
			String txtpass = apellidos.getText().toString();
			if(txtpass==null || txtpass.length()==0){
				Toast.makeText(getBaseContext(),
						"Debe escribir sus apellido/s",
						Toast.LENGTH_LONG).show();
				return;
			}
			
			
			String dni = dnitxt.getText().toString();
			if(dni==null || dni.length()==0){
				Toast.makeText(getBaseContext(),
						"Debe escribir su DNI o documento acreditativo",
						Toast.LENGTH_LONG).show();
				return;
			}
			
			String fechanac = fechanactxt.getText().toString();
			if(fechanac==null || fechanac.length()==0){
				Toast.makeText(getBaseContext(),
						"Debe indicar su fecha de nacimiento",
						Toast.LENGTH_LONG).show();
				return;
			}
			
			progressDialog = ProgressDialog.show(this,
												  "", 
	                							 "Validando cuenta. Por favor, espere...",
	                							 true,
	                							 true);
			
			
			 Empleado content = new Empleado();	
	         content.setNombre(txtuser);
	         String splitapell[] = txtpass.split(" ");
	         content.setPrimerApellido(splitapell[0]);
	         if(splitapell.length>1)
	        	 content.setSegundoApellido(splitapell[1]);
	         content.setDocIdentificacion(dni);
	         //content.setFechaNacimiento()
			
			new EmployedAsyncRetriever().execute(content);
		}
	
	 	
		public void setValueDate(String date){
			final EditText fechanac = (EditText) findViewById(R.id.empl_fechanactxt);
			fechanac.setText(date);
		}
	
	
		/**
		 * Guarda en las preferencias los datos del empleado
		 */
	    private void savedDataEmployed(String keyEmployed){
	    	
	    	// Create our data object
	    	myData = new UserPrefsData("",keyEmployed,true,false,null);
	    	myData.setNombre(nombre.getText().toString());
	    	myData.setApellidos(apellidos.getText().toString());
	    	myData.setDocumento(dnitxt.getText().toString());
	    	myData.setFechanac(fechanactxt.getText().toString());
	    	
	    	Utils.setUserPrefs(this,myData);
	    	
	    	//Registramos el telefono en el GMCCloudMessage
	    	//GCMIntentService intentservice = new GCMIntentService();
	    	//intentservice.register(this);
	    	
	    	Intent myIntent = new Intent(EmployedActivity.this, GPSActivity.class);
	    	EmployedActivity.this.startActivity(myIntent);
	    }
	 
	
	 
	 	/**
	     * AsyncTask for retrieving the employed asociate
	     * 
	     */
	    private class EmployedAsyncRetriever extends AsyncTask<Empleado, Void, CollectionResponseEmpleado> {

	      @Override
	      protected CollectionResponseEmpleado doInBackground(Empleado... params) {


	    	  Moventaaendpoint.Builder endpointBuilder = new Moventaaendpoint.Builder(
	            AndroidHttp.newCompatibleTransport(), new JacksonFactory(), null);
	       
	        endpointBuilder = CloudEndpointUtils.updateBuilder(endpointBuilder);

	        CollectionResponseEmpleado result = null;
	        Moventaaendpoint endpoint = endpointBuilder.build();

	        try {
	         com.example.moventaa.bean.moventaaendpoint.Moventaaendpoint.Search.Empleado lstemple = endpoint.search().empleado(params[0]);
	         
	          result = lstemple.execute();
	          //result = endpoint.listEmpleado()
	        		  
	        } catch (IOException e) {
	          // TODO Auto-generated catch block
	          e.printStackTrace();
	          result = null;
	        }
	        return result;
	      }

	      @Override
	      @SuppressWarnings("null")
	      protected void onPostExecute(CollectionResponseEmpleado result) {

	    	  super.onPostExecute(result);
			  progressDialog.dismiss();
			  if (result == null || result.getItems() == null || result.getItems().size() < 1) {
					  Toast.makeText(getBaseContext(),
								"Empleado no encontrado, compruebe sus datos",
								Toast.LENGTH_LONG).show();
					
				} else {
					Empleado data = result.getItems().get(0);
					savedDataEmployed(data.getKey().getName());
				}    
	      }
	   }
	    
	    
	    //http://developer.android.com/guide/topics/ui/controls/pickers.html
	    //http://www.codinguser.com/2012/06/time-and-date-inputs-in-android/
	    //http://www.mkyong.com/android/android-date-picker-example/
	class DatePickerFragment extends DialogFragment implements
			DatePickerDialog.OnDateSetListener {

		@Override
		public Dialog onCreateDialog(Bundle savedInstanceState) {
			// Use the current date as the default date in the picker
			final Calendar c = Calendar.getInstance();
			int year = c.get(Calendar.YEAR);
			int month = c.get(Calendar.MONTH);
			int day = c.get(Calendar.DAY_OF_MONTH);

			// Create a new instance of DatePickerDialog and return it
			return new DatePickerDialog(getActivity(), this, year, month, day);
		}

		public void onDateSet(DatePicker view, int year, int month, int day) {
			// Do something with the date chosen by the user
			
			// set selected date into textview
			EmployedActivity.this.setValueDate(new StringBuilder().append(day)
					   .append("/").append(month + 1).append("/").append(year)
					   .append(" ").toString());
			
 		}
   }    
	
	
	
}


