package com.example.moventaa;

import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

import android.annotation.SuppressLint;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v4.app.FragmentActivity;
import android.support.v4.app.FragmentTransaction;
import android.view.View;
import android.widget.Button;
import android.widget.Toast;

import com.example.moventaa.R;
import com.example.moventaa.bean.moventaaendpoint.Moventaaendpoint;
import com.example.moventaa.bean.moventaaendpoint.Moventaaendpoint.GetVacacionesEmpleado;
import com.example.moventaa.bean.moventaaendpoint.Moventaaendpoint.InsertVacacionesEmpleado;
import com.example.moventaa.bean.moventaaendpoint.model.CollectionResponseVacaciones;
import com.example.moventaa.bean.moventaaendpoint.model.Vacaciones;
import com.google.api.client.extensions.android.http.AndroidHttp;
import com.google.api.client.json.jackson2.JacksonFactory;
import com.roomorama.caldroid.CaldroidFragment;
import com.roomorama.caldroid.CaldroidListener;

/**
 * Implemetacion de un calendario para que el usuario
 * intoduzca la fechas a las que solicita vacaciones
 * 
 * @author mmartinezced
 *
 */
@SuppressLint("SimpleDateFormat")
public class VacacionesActivity extends FragmentActivity {
	
	private boolean undo = false;
	private CaldroidFragment caldroidFragment;
		
	//Selected dates
	private List<Date> selectedDate = new ArrayList<Date>();
	

	private void setCustomResourceForDates() {
		Calendar cal = Calendar.getInstance();

		// Min date is last 7 days
		cal.add(Calendar.DATE, -18);
		Date blueDate = cal.getTime();

		// Max date is next 7 days
		cal = Calendar.getInstance();
		cal.add(Calendar.DATE, 16);
		Date greenDate = cal.getTime();

/*		if (caldroidFragment != null) {
			caldroidFragment.setBackgroundResourceForDate(R.color.blue,	blueDate);
			caldroidFragment.setBackgroundResourceForDate(R.color.green, greenDate);
			caldroidFragment.setTextColorForDate(R.color.white, blueDate);
			caldroidFragment.setTextColorForDate(R.color.white, greenDate);
		}
		*/
	}

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_vacaciones);

    	final AppGlobal globalVariable = (AppGlobal) getApplicationContext();

				
		final SimpleDateFormat formatter = new SimpleDateFormat("dd MMM yyyy");

		// Setup caldroid fragment
		// **** If you want normal CaldroidFragment, use below line ****
		caldroidFragment = new CaldroidFragment();
		
		// //////////////////////////////////////////////////////////////////////
		// **** This is to show customized fragment. If you want customized
		// version, uncomment below line ****
//		 caldroidFragment = new CaldroidSampleCustomFragment();

		// Setup arguments

		// If Activity is created after rotation
		if (savedInstanceState != null) {
			caldroidFragment.restoreStatesFromKey(savedInstanceState,
					"CALDROID_SAVED_STATE");
		}
		// If activity is created from fresh
		else {
			Bundle args = new Bundle();
			Calendar cal = Calendar.getInstance();
			args.putInt(CaldroidFragment.MONTH, cal.get(Calendar.MONTH) + 1);
			args.putInt(CaldroidFragment.YEAR, cal.get(Calendar.YEAR));
			args.putBoolean(CaldroidFragment.ENABLE_SWIPE, true);
			args.putBoolean(CaldroidFragment.SIX_WEEKS_IN_CALENDAR, true);

			// Uncomment this to customize startDayOfWeek
			// args.putInt(CaldroidFragment.START_DAY_OF_WEEK,
			// CaldroidFragment.TUESDAY); // Tuesday
			caldroidFragment.setArguments(args);
		}

		setCustomResourceForDates();

		// Attach to the activity
		FragmentTransaction t = getSupportFragmentManager().beginTransaction();
		t.replace(R.id.calendar1, caldroidFragment);
		t.commit();

		// Setup listener
		final CaldroidListener listener = new CaldroidListener() {
			@Override
			public void onSelectDate(Date date, View view) {
				if(selectedDate.contains(date)){
					 caldroidFragment.setBackgroundResourceForDate(R.color.white,date);
					 caldroidFragment.setTextColorForDate(R.color.black, date);
					 selectedDate.remove(date);
				}else{
				     caldroidFragment.setBackgroundResourceForDate(R.color.blue, date);
				     caldroidFragment.setTextColorForDate(R.color.white, date);
				     selectedDate.add(date);
				}  
				caldroidFragment.refreshView();
			}

			@Override
			public void onChangeMonth(int month, int year) {
				VacacionesTaskRetriever retriever = new VacacionesTaskRetriever();
		    	retriever.execute("get",globalVariable.getEmpleadoID(),month,year);
			}

			@Override
			public void onLongClickDate(Date date, View view) {}

			@Override
			public void onCaldroidViewCreated() {}
		};
		// Setup Caldroid
		caldroidFragment.setCaldroidListener(listener);
		
		final Button button = (Button) findViewById(R.id.btnSolicitarStock);
        button.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
            	VacacionesTaskRetriever retriever = new VacacionesTaskRetriever();
            	retriever.execute("insert",globalVariable.getEmpleadoID(),selectedDate);
            }
        });
        
	}

	/**
	 * Save current states of the Caldroid here
	 */
	@Override
	protected void onSaveInstanceState(Bundle outState) {
		// TODO Auto-generated method stub
		super.onSaveInstanceState(outState);

		if (caldroidFragment != null) {
			caldroidFragment.saveStatesToKey(outState, "CALDROID_SAVED_STATE");
		}
	}
	
	private void fillDataCalendar(List<Vacaciones> items) {
		for (Vacaciones vacaciones : items) {
			Date date = new Date(vacaciones.getDate().getValue());
			caldroidFragment.setBackgroundResourceForDate(R.color.blue, date);
		    caldroidFragment.setTextColorForDate(R.color.white, date);
		    selectedDate.add(date);
		}
		caldroidFragment.refreshView();
	}
	
	
	private class VacacionesTaskRetriever extends AsyncTask<Object, Void, Object> {

		/**
		 * Calls appropriate CloudEndpoint to indicate that user checked into a
		 * place.
		 *
		 * @param params
		 *            the place where the user is checking in.
		 */
		@Override
		protected Object doInBackground(Object ... params) {
			
			
			Moventaaendpoint.Builder builder = new Moventaaendpoint.Builder(
					AndroidHttp.newCompatibleTransport(), new JacksonFactory(),
					null);
			builder = CloudEndpointUtils.updateBuilder(builder);
			Moventaaendpoint endpoint = builder.build();
			CollectionResponseVacaciones collection = null;
			try {
				
				if("insert".equals(params[0])){
					List<Date> datos = (List<Date>)params[2];
					for (Date datedatos : datos) {
						InsertVacacionesEmpleado insert = endpoint.insertVacacionesEmpleado();
						insert.setIdEmpleado((String)params[1]);
						insert.setVacaciones(datedatos.getTime());
						insert.execute();
					}
					return "enviadas";
				}else if("get".equals(params[0])){
				
					GetVacacionesEmpleado getvac = endpoint.getVacacionesEmpleado();
					getvac.setAnnio((Integer)params[3]);
					getvac.setMes((Integer)params[2]);
					getvac.setIdEmpleado((String)params[1]);
					collection = getvac.execute();
				}
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			return collection;
	   }
		
	   @SuppressWarnings("null")
	   protected void onPostExecute(Object result) {
       	  super.onPostExecute(result);
       	  
       	  if(result instanceof CollectionResponseVacaciones && ((CollectionResponseVacaciones)result).getItems()!=null){
       		  fillDataCalendar(((CollectionResponseVacaciones)result).getItems());
       		  
       	  }else if(result instanceof String && "enviadas".equals(result)){
       		Toast.makeText(getBaseContext(),
    				"Solicitud de vacaciones enviada",
    				Toast.LENGTH_LONG).show(); 
       	  }
	   }
	}  
}
