package com.example.moventaa.presenter;

import java.util.List;

import com.example.moventaa.bean.moventaaendpoint.model.Localidad;
import com.example.moventaa.bean.moventaaendpoint.model.Provincia;

/**
 * Interface para comunicar entre la vista y el presenter
 * @author mmartinezced
 *
 */
public interface IBusquedaCentrosView {
	
	/**
	 * Cargador de localidades
	 * @param list
	 */
	public void loadSpinnerLocalidades(List<Localidad> list);
	
	
	/**
	 * Cargador de provincias
	 * @param list
	 */
	public void loadSpinnerProvincias(List<Provincia> list);
	
	/**
	 * Buscador de localidades por id de provincia
	 * @param idLocalidad
	 */
	public void searchLocalidades(String idProvincia);
	
	/**
	 * Obtencion de provincias
	 */
	public void searchProvincias();

}
