package com.example.moventaa.utils;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.google.gson.Gson;

/**
 * Clase con los datos de las preferencias y 
 * valores guardados por el usuario
 * 
 * @author mmartinezced
 *
 */
public class UserPrefsData {


	//centro en el que esta trabajando
	private String idCentro;
	
	private List<String> centros;
	
	//codigo identificado del empleado
	private String idEmpleado;
	
	//nombre empleado
	private String nombre;
	private String apellidos;
	private String documento;
	private String fechanac;
	
	 
	//si ha sigo registrado en el sistema
	private Boolean registred;
	
	//si ha activado el uso del gps
	private Boolean gpsenabled;
	
	// ~ -- getter&setter
	

	public UserPrefsData(String idCentro, String idEmpleado,
			Boolean registred, Boolean gpsenabled, List<String> centros) {
		super();
		this.idCentro = idCentro;
		this.idEmpleado = idEmpleado;
		this.registred = registred;
		this.gpsenabled = gpsenabled;
		this.centros = centros;
	}	
	
	 
	public String serialize() {
	    // Serialize this class into a JSON string using GSON
	    Gson gson = new Gson();
	    return gson.toJson(this);
	}
	 
	static public UserPrefsData create(String serializedData) {
	    // Use GSON to instantiate this class using the JSON representation of the state
	    Gson gson = new Gson();
	   return gson.fromJson(serializedData, UserPrefsData.class);
    }
	
	

	public String getIdCentro() {
		return idCentro;
	}

	public void setIdCentro(String idCentro) {
		this.idCentro = idCentro;
	}

	public String getIdEmpleado() {
		return idEmpleado;
	}

	public void setIdEmpleado(String idEmpleado) {
		this.idEmpleado = idEmpleado;
	}

	public Boolean getRegistred() {
		return registred;
	}

	public void setRegistred(Boolean registred) {
		this.registred = registred;
	}

	public Boolean getGpsenabled() {
		return gpsenabled;
	}

	public void setGpsenabled(Boolean gpsenabled) {
		this.gpsenabled = gpsenabled;
	}


	public List<String> getCentros() {
		if(centros == null){
			centros = new ArrayList<String>();
		}
		return centros;
	}


	public void setCentros(List<String> centros) {
		this.centros = centros;
	}


	public String getNombre() {
		return nombre;
	}


	public void setNombre(String nombre) {
		this.nombre = nombre;
	}


	public String getApellidos() {
		return apellidos;
	}


	public void setApellidos(String apellidos) {
		this.apellidos = apellidos;
	}


	public String getDocumento() {
		return documento;
	}


	public void setDocumento(String documento) {
		this.documento = documento;
	}


	public String getFechanac() {
		return fechanac;
	}


	public void setFechanac(String fechanac) {
		this.fechanac = fechanac;
	}
	
}
