package com.example.moventaa.utils;

import java.net.HttpURLConnection;
import java.net.URL;

import android.app.Activity;
import android.content.Context;
import android.content.SharedPreferences;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.util.Log;

import com.example.moventaa.MainActivity;

/**
 * Clase de utilidades
 * 
 * @author mmartinezced
 *
 */
public class Utils {
	
	//private static final String URL = "http://moventaa.appspot.com/";
	private static final String URL = "http://10.0.2.2:8888"; 
			//"http://192.168.1.10:8888";
	
	public static UserPrefsData getUserPrefs(Activity activity){
		SharedPreferences sharedPref = activity.getSharedPreferences(
				MainActivity.PREFS_NAME, Context.MODE_PRIVATE);
		String serializedDataFromPreference = sharedPref.getString(
				MainActivity.PREFS_KEY, null);
		UserPrefsData restoredMyData = UserPrefsData
				.create(serializedDataFromPreference);
		return restoredMyData;
	}
	
	public static void setUserPrefs(Activity activity,UserPrefsData myData){
		SharedPreferences sharedPref = activity.getSharedPreferences(MainActivity.PREFS_NAME,Context.MODE_PRIVATE);
    	SharedPreferences.Editor editor = sharedPref.edit();
    	
    	editor.putString(MainActivity.PREFS_KEY, myData.serialize());
    	editor.commit();
	}
	
	
	public static Bitmap getImageUrl(String url) {
		Bitmap loadedImage = null;
		try{ 
			URL urldir = new URL(url);
			loadedImage = getImageUrl(urldir);
		}catch (Exception e) {
			  Log.e("Utils", e.getMessage());
	    }	  	
		return loadedImage;
	}
	
	
	/**
	 * Get de image form URL
	 * @param url
	 * @return
	 */
	private static Bitmap getImageUrl(URL url) {
		  Bitmap loadedImage = null;
		  try{
	          HttpURLConnection conn = (HttpURLConnection) url.openConnection();
	          conn.setDefaultUseCaches(true);
	          conn.connect();
	           loadedImage = BitmapFactory.decodeStream(conn.getInputStream());
		  }catch (Exception e) {
			  Log.e("Utils", e.getMessage());
		  }	  
			  
		  return loadedImage;
	 }
	
	
	
	public static String getProductsUrlImage(String id){
		return URL + "/img/products/" + id + ".jpg";
	}
	
	
	public static String getNominaURL(String mes,String dni){
		return URL + "/nominas/" + mes + "-" + dni + ".pdf";
	}
	
	public static String getProductsUrlInfo(String id){
		return URL + "/productos/" + id + ".html";
	}
}
